//***************************************************************************
// Ces applets viennent en complment du livre :
//
//  		VIE ARTIFICIELLE
//      O la biologie rencontre l'informatique
//		Illustr en Java
//            Jean-Philippe Rennard
//           	  Vuibert 2002
//===========================================================================
//  L-systmes
//    v:0.1 09/09/2002
//
//  Cette applet permet de construire des L-systmes.
//
//    Jean-Philippe Rennard 2001-2002
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package lsys;

/** Gestion d'une rgle */
public class Cregle {
  /** Caractre source */
  char source;
  /** Chane destination */
  String dest;

  /** Construit la rgle avec source/destination */
  public Cregle(char s, String d) {
    source=s;
    dest=d;
  }
  /** Vrifie si une rgle est applicable  une position donne */
  private boolean estDansRegle(String s, int pos) {
    if(s.charAt(pos)==source)
      return true;
    return false;
  }
  /** Applique la rgle */
  String appliqueRegle(String s, int pos) {
    if(source=='_' || !estDansRegle(s.toString(), pos))
      return "";
    String w=s;
    s = w.substring(0,pos);
    s += dest;
    s += w.substring(pos+1);
    return s;
  }
}