//***************************************************************************
// Ces applets viennent en complment du livre :
//
//  		VIE ARTIFICIELLE
//      O la biologie rencontre l'informatique
//		Illustr en Java
//            Jean-Philippe Rennard
//           	  Vuibert 2002
//===========================================================================
//  L-systmes
//    v:0.1 09/09/2002
//
//  Cette applet permet de construire des L-systmes.
//
//    Jean-Philippe Rennard 2001-2002
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package lsys;

import java.awt.*;
import java.awt.event.*;
import vabase.*;

/** Interface de l'applet L-systmes */
public class lsysUI extends Cui {

  /** Le L-systme */
  Clsys lSys;

  /** lments d'interface */
  BorderLayout borderLayout1 = new BorderLayout();
  Panel panelVue = new Panel();
  Panel panel1 = new Panel();
  Choice chRegle = new Choice();
  Panel panel2 = new Panel();
  GridLayout gridLayout1 = new GridLayout();
  Panel panel3 = new Panel();
  Panel panel4 = new Panel();
  Panel panel5 = new Panel();
  Button btnConstruit = new Button();
  GridLayout gridLayout2 = new GridLayout();
  Button btnPas = new Button();
  Button btnGo = new Button();
  GridLayout gridLayout3 = new GridLayout();
  Panel panel6 = new Panel();
  Panel panel7 = new Panel();
  GridLayout gridLayout4 = new GridLayout();
  TextField txtR6A = new TextField();
  TextField txtR5R = new TextField();
  TextField txtR6R = new TextField();
  TextField txtR4A = new TextField();
  Label label2 = new Label();
  Label label3 = new Label();
  Panel panel8 = new Panel();
  Panel panel9 = new Panel();
  GridLayout gridLayout5 = new GridLayout();
  Label label5 = new Label();
  TextField txtAxiome = new TextField();
  GridLayout gridLayout6 = new GridLayout();
  Label label6 = new Label();
  TextField txtNbDir = new TextField();
  GridLayout gridLayout7 = new GridLayout();
  Label label7 = new Label();
  TextField txtLg = new TextField();
  Panel panel10 = new Panel();
  GridLayout gridLayout8 = new GridLayout();
  Panel panel11 = new Panel();
  Label label8 = new Label();
  TextField txtIteration = new TextField();
  GridLayout gridLayout9 = new GridLayout();
  Panel panel13 = new Panel();
  GridLayout gridLayout11 = new GridLayout();
  Panel panel14 = new Panel();
  GridLayout gridLayout12 = new GridLayout();
  TextField txtR4R = new TextField();
  Panel panel17 = new Panel();
  Label label9 = new Label();
  TextField txtR5A = new TextField();
  GridLayout gridLayout15 = new GridLayout();
  Label label10 = new Label();
  TextField txtR2R = new TextField();
  TextField txtR3A = new TextField();
  Panel panel12 = new Panel();
  Label label4 = new Label();
  Label label11 = new Label();
  TextField txtR3R = new TextField();
  GridLayout gridLayout16 = new GridLayout();
  GridLayout gridLayout10 = new GridLayout();
  TextField txtR2A = new TextField();
  Panel panel18 = new Panel();
  GridLayout gridLayout13 = new GridLayout();
  TextField txtR1R = new TextField();
  Panel panel15 = new Panel();
  GridLayout gridLayout14 = new GridLayout();
  Panel panel16 = new Panel();
  TextField txtR1A = new TextField();
  Panel panel19 = new Panel();
  Label label1 = new Label();
  TextField txtAngDep = new TextField();
  GridLayout gridLayout17 = new GridLayout();
  Label label12 = new Label();
  TextField txtRatioLg = new TextField();
  Panel panel20 = new Panel();
  Label label13 = new Label();
  TextField txtPosX = new TextField();
  GridLayout gridLayout18 = new GridLayout();
  Label label14 = new Label();
  TextField txtPosY = new TextField();
  GridLayout gridLayout19 = new GridLayout();
  Button btnValide = new Button();
  GridLayout gridLayout20 = new GridLayout();
  TextField txtGenome = new TextField();
  GridLayout gridLayout21 = new GridLayout();
  TextField txtLenGenome = new TextField();
  Button btnAff = new Button();

  /** Constructeur, construit le L-systme */
  public lsysUI(lsysLaunch am) {
    super((Claunch)am);
    lSys=new Clsys(this);
    process=(Cprocess)lSys;
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /** Initialisation */
  private void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    panelVue.setBackground(Color.green);
    panelVue.addComponentListener(new java.awt.event.ComponentAdapter() {
      public void componentResized(ComponentEvent e) {
        panelVue_componentResized(e);
      }
    });
    panelVue.setLayout(gridLayout2);
    panel1.setLayout(gridLayout3);
    panel2.setLayout(gridLayout1);
    gridLayout1.setColumns(3);
    btnConstruit.setLabel("Construit");
    btnConstruit.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        btnConstruit_mouseClicked(e);
      }
    });
    btnPas.setLabel("Pas  pas");
    btnPas.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnPas_actionPerformed(e);
      }
    });
    btnGo.setLabel("Go");
    btnGo.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnGo_actionPerformed(e);
      }
    });
    panel6.setLayout(gridLayout4);
    gridLayout4.setRows(3);
    gridLayout4.setColumns(6);
    label2.setText("R4");
    label3.setText("R6");
    panel7.setLayout(gridLayout5);
    gridLayout5.setRows(3);
    label5.setText("Axiome");
    panel8.setLayout(gridLayout6);
    label6.setText("Dir.");
    panel9.setLayout(gridLayout7);
    label7.setText("Long.");
    panel10.setLayout(gridLayout8);
    gridLayout8.setRows(3);
    label8.setText("Itrations");
    panel11.setLayout(gridLayout9);
    panel13.setLayout(gridLayout11);
    panel14.setLayout(gridLayout12);
    chRegle.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        chRegle_itemStateChanged(e);
      }
    });
    gridLayout3.setColumns(4);
    panel17.setLayout(gridLayout15);
    label9.setText("R5");
    label10.setText("R2");
    panel12.setLayout(gridLayout10);
    label4.setText("R3");
    label11.setText("R1");
    gridLayout10.setRows(3);
    gridLayout10.setColumns(6);
    panel18.setLayout(gridLayout16);
    panel15.setLayout(gridLayout13);
    panel16.setLayout(gridLayout14);
    label1.setText("Ang.");
    panel19.setLayout(gridLayout17);
    label12.setText("RL.");
    label13.setText("PosX");
    panel20.setLayout(gridLayout18);
    label14.setText("PosY");
    panel3.setLayout(gridLayout19);
    btnValide.setLabel("Valide/Init.");
    btnValide.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnValide_actionPerformed(e);
      }
    });
    panel4.setLayout(gridLayout20);
    panel5.setLayout(gridLayout21);
    txtIteration.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtIteration_focusGained(e);
      }
    });
    txtPosX.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtPosX_focusGained(e);
      }
    });
    txtPosY.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtPosY_focusGained(e);
      }
    });
    txtR1A.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtR1A_focusGained(e);
      }
    });
    txtR1R.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtR1R_focusGained(e);
      }
    });
    txtR2A.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtR2A_focusGained(e);
      }
    });
    txtR2R.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtR2R_focusGained(e);
      }
    });
    txtR3A.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtR3A_focusGained(e);
      }
    });
    txtR3R.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtR3R_focusGained(e);
      }
    });
    txtR4A.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtR4A_focusGained(e);
      }
    });
    txtR4R.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtR4R_focusGained(e);
      }
    });
    txtR5A.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtR5A_focusGained(e);
      }
    });
    txtR5R.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtR5R_focusGained(e);
      }
    });
    txtR6A.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtR6A_focusGained(e);
      }
    });
    txtR6R.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtR6R_focusGained(e);
      }
    });
    txtAxiome.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtAxiome_focusGained(e);
      }
    });
    txtNbDir.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtNbDir_focusGained(e);
      }
    });
    txtLg.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtLg_focusGained(e);
      }
    });
    txtAngDep.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtAngDep_focusGained(e);
      }
    });
    txtRatioLg.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        txtRatioLg_focusGained(e);
      }
    });
    btnAff.setLabel("Affiche");
    btnAff.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnAff_actionPerformed(e);
      }
    });
    this.add(panelVue, BorderLayout.CENTER);
    this.add(panel1, BorderLayout.NORTH);
    panel1.add(panel10, null);
    panel10.add(chRegle, null);
    panel10.add(panel11, null);
    panel11.add(label8, null);
    panel11.add(txtIteration, null);
    panel10.add(panel20, null);
    panel20.add(label13, null);
    panel20.add(txtPosX, null);
    panel20.add(label14, null);
    panel20.add(txtPosY, null);
    panel1.add(panel12, null);
    panel16.add(label11, null);
    panel16.add(txtR1A, null);
    panel12.add(panel16, null);
    panel12.add(txtR1R, null);
    panel12.add(panel18, null);
    panel18.add(label10, null);
    panel18.add(txtR2A, null);
    panel12.add(txtR2R, null);
    panel12.add(panel15, null);
    panel15.add(label4, null);
    panel15.add(txtR3A, null);
    panel12.add(txtR3R, null);
    panel1.add(panel6, null);
    panel6.add(panel13, null);
    panel13.add(label2, null);
    panel13.add(txtR4A, null);
    panel17.add(label9, null);
    panel17.add(txtR5A, null);
    panel6.add(txtR4R, null);
    panel6.add(panel17, null);
    panel6.add(txtR5R, null);
    panel6.add(panel14, null);
    panel14.add(label3, null);
    panel14.add(txtR6A, null);
    panel6.add(txtR6R, null);
    panel1.add(panel7, null);
    panel7.add(panel8, null);
    panel8.add(label5, null);
    panel8.add(txtAxiome, null);
    panel7.add(panel9, null);
    panel9.add(label6, null);
    panel9.add(txtNbDir, null);
    panel9.add(label7, null);
    panel9.add(txtLg, null);
    panel7.add(panel19, null);
    panel19.add(label1, null);
    panel19.add(txtAngDep, null);
    panel19.add(label12, null);
    panel19.add(txtRatioLg, null);
    this.add(panel2, BorderLayout.SOUTH);
    panel2.add(panel5, null);
    panel5.add(btnConstruit, null);
    panel5.add(btnValide, null);
    panel2.add(panel4, null);
    panel4.add(txtGenome, null);
    panel2.add(panel3, null);
    panel3.add(txtLenGenome, null);
    panel3.add(btnPas, null);
    panel3.add(btnGo, null);
    panel3.add(btnAff, null);
    // Remplissage liste de choix
    chRegle.addItem("Plante 1");
    chRegle.addItem("Plante 2");
    chRegle.addItem("Koch");
    chRegle.addItem("Buisson 1");
    chRegle.addItem("Buisson 2");
    chRegle.addItem("Triangles");
    chRegle.addItem("Squigly");
    chRegle.addItem("Hilbert");
    chRegle.addItem("Plantes");
    chRegle.addItem("Sierpinsky");
    chRegle.addItem("Arbre");
    chRegle.addItem("Plante 3");
    chRegle.addItem("ABOP 1.24");

    // Ajout de la vue dans un panel
    panelVue.add(lSys.lsysVue,null);
  }
  /** Initialisation du monde */
  public void start() {
    process.initVue();
    affData();
  }
  /** Affichage gnration */
  public void affGeneration() {
    txtLenGenome.setText(Integer.toString(lSys.genome.length())+"/"+
        lSys.generation);
  }
  /** Lancement de la construction de gnome */
  void btnConstruit_mouseClicked(MouseEvent e) {
    lSys.appliqueRegles();
    btnGo.setEnabled(true);
    btnPas.setEnabled(true);
    btnAff.setEnabled(true);
  }
  /** Affichage pas  pas */
  void btnPas_actionPerformed(ActionEvent e) {
    lSys.pasAPas();
  }
  /** Affichage dynamique */
  void btnGo_actionPerformed(ActionEvent e) {
    if(lSys.isRunning==false) {
      btnGo.setLabel("Stop");
      setInterface(false);
      btnGo.setEnabled(true);
      lSys.lancement(false);
    }
    else {
      lSys.vue.repaint();
      btnGo.setLabel("Go");
      lSys.stop();
      stop();
      setInterface(true);
    }
  }
  /** Affichage complet aprs calcul */
  void btnAff_actionPerformed(ActionEvent e) {
    if(lSys.isRunning==false) {
      lSys.initVue();
      btnGo.setLabel("Stop");
      setInterface(false);
      btnGo.setEnabled(true);
      lSys.lancement(true);
    }
  }
  /** Arrt affichage */
  void stop() {
    setInterface(true);
    btnGo.setLabel("Go");
  }
  /** Redimensionnement de la vue graphique */
  void panelVue_componentResized(ComponentEvent e) {
    redimUi();
  }
  /** Choix d'une rgle */
  void chRegle_itemStateChanged(ItemEvent e) {
    lSys.choixRegle(chRegle.getSelectedIndex());
    affData();
  }
  /** Affichage des paramtres d'un L-system */
  void affData() {
    lSys.initVue();
    txtR1A.setText(""+lSys.regles[0].source);
    txtR1R.setText(""+lSys.regles[0].dest);
    txtR2A.setText(""+lSys.regles[1].source);
    txtR2R.setText(""+lSys.regles[1].dest);
    txtR3A.setText(""+lSys.regles[2].source);
    txtR3R.setText(""+lSys.regles[2].dest);
    txtR4A.setText(""+lSys.regles[3].source);
    txtR4R.setText(""+lSys.regles[3].dest);
    txtR5A.setText(""+lSys.regles[4].source);
    txtR5R.setText(""+lSys.regles[4].dest);
    txtR6A.setText(""+lSys.regles[5].source);
    txtR6R.setText(""+lSys.regles[5].dest);
    txtAxiome.setText(lSys.axiome);
    txtNbDir.setText(Integer.toString(lSys.nbDir));
    txtLg.setText(Float.toString(lSys.lgBase));
    txtIteration.setText(Integer.toString(lSys.iteration));
    txtPosX.setText(Float.toString(lSys.posDepX));
    txtPosY.setText(Float.toString(lSys.posDepY));
    txtAngDep.setText(Float.toString(lSys.angleDep));
    txtRatioLg.setText(Float.toString(lSys.ratioEchelle));
    txtGenome.setText("");
    txtLenGenome.setText("0");
    btnGo.setEnabled(false);
    btnPas.setEnabled(false);
    btnAff.setEnabled(false);
  }
  /** Modification manuelle d'un L-systme */
  void modifSystemeEC() {
    setInterface(false);
    setParamInterface(true);
    btnValide.setEnabled(true);
  }
  /** Modification du nombre d'itrations */
  void txtIteration_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification de la position de dpart en x */
  void txtPosX_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification de la position de dpart en y */
  void txtPosY_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification d'une rgle */
  void txtR1A_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification d'une rgle */
  void txtR1R_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification d'une rgle */
  void txtR2A_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification d'une rgle */
  void txtR2R_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification d'une rgle */
  void txtR3A_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification d'une rgle */
  void txtR3R_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification d'une rgle */
  void txtR4A_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification d'une rgle */
  void txtR4R_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification d'une rgle */
  void txtR5A_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification d'une rgle */
  void txtR5R_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification d'une rgle */
  void txtR6A_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification d'une rgle */
  void txtR6R_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification de l'axiome */
  void txtAxiome_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification du nombre de directions */
  void txtNbDir_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification de la longueur de base */
  void txtLg_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification de l'angle de dpart */
  void txtAngDep_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Modification du ratio des longueurs */
  void txtRatioLg_focusGained(FocusEvent e) {
    modifSystemeEC();
  }
  /** Validation d'une nouvelle rgle manuelle */
  void btnValide_actionPerformed(ActionEvent e) {
    creeRegle();
    setInterface(true);
    affData();
  }
  /** Construction d'un rgle manuelle */
  void creeRegle() {
    lSys.setRegles(Float.valueOf(txtRatioLg.getText()).floatValue(),
                  Integer.parseInt(txtNbDir.getText()),
                  Float.valueOf(txtLg.getText()).floatValue(),
                  Float.valueOf(txtAngDep.getText()).floatValue(),
                  Float.valueOf(txtPosX.getText()).floatValue(),
                  Float.valueOf(txtPosY.getText()).floatValue(),
                  Integer.parseInt(txtIteration.getText()),
                  txtAxiome.getText(),
                  txtR1A.getText().charAt(0),
                  txtR1R.getText(),
                  txtR2A.getText().charAt(0),
                  txtR2R.getText(),
                  txtR3A.getText().charAt(0),
                  txtR3R.getText(),
                  txtR3A.getText().charAt(0),
                  txtR4R.getText(),
                  txtR4A.getText().charAt(0),
                  txtR5R.getText(),
                  txtR4A.getText().charAt(0),
                  txtR6R.getText());
  }
  /** (in)activation interface */
  public void setInterface(boolean e) {
    btnConstruit.setEnabled(e);
    btnGo.setEnabled(e);
    btnPas.setEnabled(e);
    btnValide.setEnabled(e);
    btnAff.setEnabled(e);
    chRegle.setEnabled(e);
    setParamInterface(e);
  }
  /** (in)activation des paramtres */
  public void setParamInterface(boolean e) {
    txtAngDep.setEnabled(e);
    txtAxiome.setEnabled(e);
    txtIteration.setEnabled(e);
    txtLg.setEnabled(e);
    txtNbDir.setEnabled(e);
    txtPosX.setEnabled(e);
    txtPosY.setEnabled(e);
    txtRatioLg.setEnabled(e);
    txtR1A.setEnabled(e);
    txtR1R.setEnabled(e);
    txtR2A.setEnabled(e);
    txtR2R.setEnabled(e);
    txtR3A.setEnabled(e);
    txtR3R.setEnabled(e);
    txtR4A.setEnabled(e);
    txtR4R.setEnabled(e);
    txtR5A.setEnabled(e);
    txtR5R.setEnabled(e);
    txtR6A.setEnabled(e);
    txtR6R.setEnabled(e);
  }
}
